/*
	minitar
	tar32.dll test program
	by Yoshioka Tsuneo(QWF00133@nifty.ne.jp)
	Copy,Edit,Re-distribute FREE!

	Modified by ICHIMARU Takeshi(ayakawa.m@gmail.com)
*/
#include <windows.h>
#include <stdio.h>

#define FNAME_MAX32		512
typedef struct {
	DWORD 			dwOriginalSize;
	DWORD 			dwCompressedSize;
	DWORD			dwCRC;
	UINT			uFlag;
	UINT			uOSType;
	WORD			wRatio;
	WORD			wDate;
	WORD 			wTime;
	char			szFileName[FNAME_MAX32 + 1];
	char			dummy1[3];
	char			szAttribute[8];
	char			szMode[8];
}	INDIVIDUALINFO;

typedef WORD(WINAPI* fncTarGetVersion)(VOID);
typedef int (WINAPI* fncTar)(HWND hwnd, char* cmd, char* buff, int buflen);
typedef int (WINAPI* fncTarCheckArchive)(char* fname, int mode);
typedef HANDLE(WINAPI* fncTarOpenArchive)(HANDLE hwnd, char* fname, int mode);
typedef int	(WINAPI* fncTarCloseArchive)(HANDLE harc);
typedef int (WINAPI* fncTarFindFirst)(HANDLE hwnd, char* fname, INDIVIDUALINFO* pinfo);
typedef int (WINAPI* fncTarFindNext)(HANDLE hwnd, INDIVIDUALINFO* pinfo);
typedef BOOL(WINAPI* fncTarConfigDialog)(const HWND _hwnd, LPSTR _lpszComBuffer, const int _iMode);
typedef int (WINAPI* fncTarGetFileCount)(LPCSTR _szArcFile);

fncTarGetVersion TarGetVersion;
fncTar Tar;
fncTarCheckArchive TarCheckArchive;
fncTarOpenArchive TarOpenArchive;
fncTarCloseArchive TarCloseArchive;
fncTarFindFirst TarFindFirst;
fncTarFindNext TarFindNext;
fncTarConfigDialog TarConfigDialog;
fncTarGetFileCount TarGetFileCount;


void SelfTest()
{
#define TESTFILE "testfile"
	FILE *fp;
	int i;
	errno_t error = fopen_s(&fp, TESTFILE, "wb");
	if (error != 0) {
		printf("cannot open %s\n", TESTFILE);
	}
	else {
		for (i = 0; i < 100; i++) {
			fprintf(fp, "%d line.\n", i);
		}
		fclose(fp);
	}
}

#define CMDBUFSIZE 1000
int main(int argc,char *argv[])
{
	char cmd[CMDBUFSIZE] = "";
	int i;
	char buff[CMDBUFSIZE+1];
	int ret;
	HANDLE hLib;
	int ver;

#ifdef _WIN64
	hLib = LoadLibrary("tar64.dll");
#else
	hLib = LoadLibrary("tar32.dll");
#endif
	TarGetVersion = (fncTarGetVersion)GetProcAddress(hLib, "TarGetVersion");
	TarCheckArchive = (fncTarCheckArchive)GetProcAddress(hLib, "TarCheckArchive");
	TarConfigDialog = (fncTarConfigDialog)GetProcAddress(hLib, "TarConfigDialog");
	Tar = (fncTar)GetProcAddress(hLib, "Tar");

	ver = TarGetVersion();
#ifdef _WIN64
	printf("tar64.dll version <%d>\n", ver);
#else
	printf("tar32.dll version <%d>\n", ver);
#endif

	for (i = 1; i < argc; i++) {
		errno_t error = strcat_s(cmd, CMDBUFSIZE, argv[i]);
		if (error != 0) {
			printf("err at making cmdstr : <%d>\n", i);
			FreeLibrary(hLib);
			return 1;
		}
		error = strcat_s(cmd, CMDBUFSIZE, " ");
		if (error != 0) {
			printf("err at making cmdstr : <%d>\n", i);
			FreeLibrary(hLib);
			return 2;
		}
	}

	if(argc>=2 && strcmp(argv[1],"selftest") == 0){
		SelfTest();
	}
	if(argc>=2 && strcmp(argv[1],"config") == 0){
		TarConfigDialog(NULL,NULL,0);
	}
	if(argc==3 && (strcmp(argv[1],"check")==0 || strcmp(argv[1],"find")==0)){
		TarCheckArchive = (fncTarCheckArchive)GetProcAddress(hLib, "TarCheckArchive");
		ret = TarCheckArchive(argv[2],0);
	}
	if(argc==3 && (strcmp(argv[1],"count")==0 || strcmp(argv[1],"find")==0)){
		TarGetFileCount = (fncTarGetFileCount)GetProcAddress(hLib, "TarGetFileCount");
		ret = TarGetFileCount(argv[2]);
		printf("count=%d\n", ret);
	}
	
	if(argc>=3 && strcmp(argv[1],"find")==0){
		HANDLE harc;
		INDIVIDUALINFO info;
		char *wildname="";

		TarFindFirst = (fncTarFindFirst)GetProcAddress(hLib, "TarFindFirst");
		TarFindNext = (fncTarFindNext)GetProcAddress(hLib, "TarFindNext");
		TarOpenArchive = (fncTarOpenArchive)GetProcAddress(hLib, "TarOpenArchive");
		TarCloseArchive = (fncTarCloseArchive)GetProcAddress(hLib, "TarCloseArchive");
		
		if((harc = TarOpenArchive(NULL,argv[2],0))==NULL){
			exit(1);
		}
		if(argc>=4){wildname=argv[3];}
		ret = TarFindFirst(harc,wildname,&info);
		while(ret!=-1){
			ret = TarFindNext(harc,&info);
		}
		ret = TarCloseArchive(harc);
	}
	if(0){
		/* system("command.com"); */
		TarGetFileCount = (fncTarGetFileCount)GetProcAddress(hLib, "TarGetFileCount");
		ret = TarGetFileCount("c:\\dostool\\utool\\uxtl305.tgz");
		ret = TarGetFileCount("c:\\dostool\\utool\\uxtl305.tar.bz2");
/*		ret = TarGetFileCount("c:\\dostool\\utool\\uxtl305.tgz");
		ret = TarGetFileCount("c:\\dostool\\utool\\uxtl305.tgz");*/
		//ret = TarGetFileCount("aiu.tgz");
	}
	{
		ret = Tar(NULL,cmd,buff,CMDBUFSIZE);
	}
	FreeLibrary(hLib);
	puts(buff);
	return 0;
}

